from zeep import Client
import base64
import urllib.request

# Przykład wywołania metody dispatch, umożliwiającej wysłanie nowej przesyłki

login = '' # Login konta w Postivo.pl
api_pass = '' # Hasło dostępu do konta przez API
msg_type = 1

# Tablica zawierająca zawartość plików z dokumentami, które powinny być umieszczone
# w przesyłce (Mozna podac wiele plików jako kolejne elementy tablicy)
document_files = [
        {'file_stream' : base64.b64encode(urllib.request.urlopen("http://bramka.gsmservice.pl/docs/HTTP_API_Bramka_SMS.pdf").read()), 'file_name' : 'Nazwa_Pliku.pdf'}
    ]

# Tablica zawierająca dane odbiorców przesyłek, id odbiorcy w książce adresowej
# lub id grupy odbiorców
recipients = [
        # Dane odbiorców podane bezpośrednio:
            {"id" : 0 ,
             "source" : "inline",
             "recipient_name" : "Jan Nowak",
             "recipient_address_prefix" : "ul.",
             "recipient_address" : "Przykładowa",
             "recipient_home_number" : "2",
             "recipient_flat_number" : "5",
             "recipient_post_code" : "00-999",
             "recipient_city" : "Warszawa"},
        # Odbiorca z książki adresowej
#            {"source" : "book", "id" : 1},
        # Odbiorcy z grupy odbiorców
#            {"source" : "group", "id" : 5}
    ];
options = [
        {"name" : "sender_id", "value" : 1}, # ID nadawcy przesyłki
	#{"name" : "config_id", "value" : 1}, # ID profilu użytej konfiguracji
	#{"name" : "dispatch_date", "value" : "2011-01-01"} # data (w przypadku faksów również godzina i minuta) nadania przesyłki
	];

try:
# Utworzenie klienta SOAP:
    client = Client("https://api.postivo.pl/webservices.php?wsdl")

# Wywołanie metody getDispatchStatus z przekazaniem wszystkich parametrów
    request_data={'login' : login,
                  'api_pass' : api_pass,
                  'msg_type' : msg_type,
                  'document_files' : document_files,
                  'recipients' : recipients,
                  'options' : options
                  }

    output=client.service.dispatch(**request_data)

# Przykład obsługi danych wyjściowych:
    print("Status żądania: "+output['result']+", kod statusu żądania: "+output['result_code']+", opis statusu żądania: "+output['result_description'])
    for shipment in output['shipments']:
        print("\nPrzesyłka dla: "+shipment['recipient_name']+", "+shipment['recipient_address']+" "+str(shipment['recipient_home_number'])+"/"+str(shipment['recipient_flat_number'])+", "+str(shipment['recipient_post_code'])+" "+shipment['recipient_city']+", składająca się z "+str(shipment['page_number'])+" stron ma status "+shipment['status']+" (kod statusu: "+shipment['status_code']+", opis kodu: "+shipment['status_description']+")", end ="");
        if shipment['status']=='OK':
            print(", zostanie nadana za pośrednictwem: "+shipment['dispatch_carrier']+", jako: "+shipment['dispatch_type']+". Jej koszt to "+str(shipment['price'])+" zł netto. Identyfikator tej przesyłki to: "+shipment['id']+".")
except:
    print("Wystąpił błąd")

